unit RStrLib;
{
  This library declared a function for decoding
  from/to any russian codepages.
  First parameter is a string for code conversion,
  second - in what to convert:
  Win from Alt: 866,
  Win from KOI-8R: 8,
  Win from KOI-8U: 88,
  Win from ISO 8859-5: 595,
  Win from Mac: 111,
  Alt from Win: -866,
  KOI-8R from Win: -8,
  KOI-8U from Win: -88,
  ISO 8859-5 from win: -595,
  Mac from win: -111.
  For recode from Alt to KOI-8, for sample, use
  recodestr twice: 1st - with second parameter = 886,
  and after - with second parameter = -8.
  Version 0.1 - near end, 1997 (Koi-Win-Alt, C/C++).
  Version 1.0 - 12.03.1998 (C to Pascal translate).
  Version 1.1 - 23.12.1998 (ISO support added).
  Version 1.2 - 10.01.1999 (MAC support added).
  Version 1.3 - 19.02.1999 (Lat/Cyr convert added).
  Version 1.4 - 15.12.2000 (KOI8-U convert added).
  Copyright (c) 1997-2000 by Serge Korzhinski.
  E-mail: serg@snkey.net
  Http://www.snkey.net
}
interface

function alttowin(alt:string):string;
function koitowin(koi:string):string;
function isotowin(iso:string):string;
function mactowin(mac:string):string;
function koiutowin(koi:string):string;
function wintomac(win:string):string;
function wintoalt(win:string):string;
function wintokoi(win:string):string;
function wintoiso(win:string):string;
function wintokoiu(win:string):string;

function lattocyr(lat:string):string;
function cyrtolat(cyr:string):string;

function recodestr(st:string;cp:integer):string;

implementation

function recodestr(st:string;cp:integer):string;
begin
 if cp=1251 then recodestr:=st
   else if cp=866 then recodestr:=alttowin(st)
     else if cp=8 then recodestr:=koitowin(st)
       else if cp=595 then recodestr:=isotowin(st)
         else if cp=111 then recodestr:=mactowin(st)
           else if cp=-866 then recodestr:=wintoalt(st)
             else if cp=-8 then recodestr:=wintokoi(st)
               else if cp=-595 then recodestr:=wintoiso(st)
                 else if cp=-111 then recodestr:=wintomac(st)
                   else if cp=88 then recodestr:=koiutowin(st)
                     else if cp=-88 then recodestr:=wintokoiu(st)
                       else recodestr:=st;
end;

function lattocyr(lat:string):string;
var
 cyr:string;
 i,a,x:integer;
begin
 a:=length(lat);
 for i:=1 to a do begin
   x:=ord(lat[i]);
   case x of
    81:x:=201;
    87:x:=214;
    69:x:=211;
    82:x:=202;
    84:x:=197;
    89:x:=205;
    85:x:=195;
    73:x:=216;
    79:x:=217;
    80:x:=199;
    123:x:=213;
    125:x:=218;
    65:x:=212;
    83:x:=219;
    68:x:=194;
    70:x:=192;
    71:x:=207;
    72:x:=208;
    74:x:=206;
    75:x:=203;
    76:x:=196;
    58:x:=198;
    34:x:=221;
    90:x:=223;
    88:x:=215;
    67:x:=209;
    86:x:=204;
    66:x:=200;
    78:x:=210;
    77:x:=220;
    60:x:=193;
    62:x:=222;
    113:x:=233;
    119:x:=246;
    101:x:=243;
    114:x:=234;
    116:x:=229;
    121:x:=237;
    117:x:=227;
    105:x:=248;
    111:x:=249;
    112:x:=231;
    91:x:=245;
    93:x:=250;
    97:x:=244;
    115:x:=251;
    100:x:=226;
    102:x:=224;
    103:x:=239;
    104:x:=240;
    106:x:=238;
    107:x:=235;
    108:x:=228;
    59:x:=230;
    96:x:=253;
    122:x:=255;
    120:x:=247;
    99:x:=241;
    118:x:=236;
    98:x:=232;
    110:x:=242;
    109:x:=252;
    44:x:=225;
    46:x:=254;
   end;
   cyr:=cyr+chr(x);
 end;
 lattocyr:=cyr;
end;

function cyrtolat(cyr:string):string;
var
 lat:string;
 i,a,x:integer;
begin
 a:=length(cyr);
 for i:=1 to a do begin
   x:=ord(cyr[i]);
   case x of
    201:x:=81;
    214:x:=87;
    211:x:=69;
    202:x:=82;
    197:x:=84;
    205:x:=89;
    195:x:=85;
    216:x:=73;
    217:x:=79;
    199:x:=80;
    213:x:=123;
    218:x:=125;
    212:x:=65;
    219:x:=83;
    194:x:=68;
    192:x:=70;
    207:x:=71;
    208:x:=72;
    206:x:=74;
    203:x:=75;
    196:x:=76;
    198:x:=58;
    221:x:=34;
    223:x:=90;
    215:x:=88;
    209:x:=67;
    204:x:=86;
    200:x:=66;
    210:x:=78;
    220:x:=77;
    193:x:=60;
    222:x:=62;
    233:x:=113;
    246:x:=119;
    243:x:=101;
    234:x:=114;
    229:x:=116;
    237:x:=121;
    227:x:=117;
    248:x:=105;
    249:x:=111;
    231:x:=112;
    245:x:=91;
    250:x:=93;
    244:x:=97;
    251:x:=115;
    226:x:=100;
    224:x:=102;
    239:x:=103;
    240:x:=104;
    238:x:=106;
    235:x:=107;
    228:x:=108;
    230:x:=59;
    253:x:=96;
    255:x:=122;
    247:x:=120;
    241:x:=99;
    236:x:=118;
    232:x:=98;
    242:x:=110;
    252:x:=109;
    225:x:=44;
    254:x:=46;
   end; //case
   lat:=lat+chr(x);
 end;
 cyrtolat:=lat;
end;

function wintoiso(win:string):string;
var
 iso:string;
 i,x,a:integer;
begin
 iso:='';
 a:=0;
 i:=length(win);
 while a<i do begin
   inc(a);
   x:=ord(win[a]);
   if x=168 then begin
     iso:=iso+chr(161);
     continue;
   end;
   if x=184 then begin
     iso:=iso+chr(241);
     continue;
   end;
   if x<192 then begin
     iso:=iso+chr(x);
     continue;
   end;
   if x>191 then begin
     iso:=iso+chr(x-16);
     continue;
   end;
 end;
 wintoiso:=iso;
end;

function isotowin(iso:string):string;
var
 win:string;
 i,x,a:integer;
begin
 win:='';
 a:=0;
 i:=length(iso);
 while a<i do begin
   inc(a);
   x:=ord(iso[a]);
   if x<161 then begin
     win:=win+chr(x);
     continue;
   end;
   if x=161 then begin
     win:=win+chr(168);
     continue;
   end;
   if x=241 then begin
     win:=win+chr(184);
     continue;
   end;
   if (x>175) and (x<240) then begin 
     win:=win+chr(x+16);
     continue;
   end else win:=win+chr(x);
 end;
 isotowin:=win;
end;

function mactowin(mac:string):string;
var
 win:string;
 k:char;
 i,x:integer;
begin
 win:='';
 for i:=1 to length(mac) do begin
   k:=mac[i];
   x:=ord(k);
   if x<128 then begin
     win:=win+chr(x);
     continue;
   end;
   if (x>127) and (x<160) then begin
     win:=win+chr(x+64);
     continue;
   end;
   if (x>223) and (x<255) then begin
     win:=win+chr(x);
     continue;
   end;
   case x of
    221:x:=168;
    222:x:=184;
    223:x:=255;
   end;
   win:=win+chr(x);
 end;
 mactowin:=win;
end;

function wintomac(win:string):string;
var
 mac:string;
 k:char;
 i,x:integer;
begin
 mac:='';
 for i:=1 to length(win) do begin
   k:=win[i];
   x:=ord(k);
   if x<128 then begin
     mac:=mac+chr(x);
     continue;
   end;
   case x of
    221:begin x:=168; mac:=mac+chr(x); continue; end;
    222:begin x:=184; mac:=mac+chr(x); continue; end;
    223:begin x:=255; mac:=mac+chr(x); continue; end;
   end;
   if (x>191) and (x<224) then begin
     mac:=mac+chr(x-64);
     continue;
   end;
   if (x>223) and (x<255) then begin
     mac:=mac+chr(x);
     continue;
   end;
   mac:=mac+chr(x);
 end;
 wintomac:=mac;
end;

function alttowin(alt:string):string;
var
 win:string;
 k:char;
 i,x:integer;
begin
 win:='';
 for i:=1 to length(alt) do begin
   k:=alt[i];
   x:=ord(k);
   if x<127 then begin
     win:=win+chr(x);
     continue;
   end;
   case x of
    128:x:=192;
    129:x:=193;
    130:x:=194;
    131:x:=195;
    132:x:=196;
    133:x:=197;
    240:x:=168;
    134:x:=198;
    135:x:=199;
    136:x:=200;
    137:x:=201;
    138:x:=202;
    139:x:=203;
    140:x:=204;
    141:x:=205;
    142:x:=206;
    143:x:=207;
    144:x:=208;
    145:x:=209;
    146:x:=210;
    147:x:=211;
    148:x:=212;
    149:x:=213;
    150:x:=214;
    151:x:=215;
    152:x:=216;
    153:x:=217;
    154:x:=218;
    155:x:=219;
    156:x:=220;
    157:x:=221;
    158:x:=222;
    159:x:=223;
    160:x:=224;
    161:x:=225;
    162:x:=226;
    163:x:=227;
    164:x:=228;
    165:x:=229;
    241:x:=184;
    166:x:=230;
    167:x:=231;
    168:x:=232;
    169:x:=233;
    170:x:=234;
    171:x:=235;
    172:x:=236;
    173:x:=237;
    174:x:=238;
    175:x:=239;
    224:x:=240;
    225:x:=241;
    226:x:=242;
    227:x:=243;
    228:x:=244;
    229:x:=245;
    230:x:=246;
    231:x:=247;
    232:x:=248;
    233:x:=249;
    234:x:=250;
    235:x:=251;
    236:x:=252;
    237:x:=253;
    238:x:=254;
    239:x:=255;
    248:x:=176;
    252:x:=169;
    255:x:=160;
   end;
   win:=win+chr(x);
 end;
 alttowin:=win;
end;

function wintoalt(win:string):string;
var
 alt:string;
 k:char;
 i,x:integer;
begin
 alt:='';
 for i:=1 to length(win) do begin
   k:=win[i];
   x:=ord(k);
   if x<127 then begin
     alt:=alt+chr(x);
     continue;
   end;
   case x of
    192:x:=128;
    193:x:=129;
    194:x:=130;
    195:x:=131;
    196:x:=132;
    197:x:=133;
    168:x:=240;
    198:x:=134;
    199:x:=135;
    200:x:=136;
    201:x:=137;
    202:x:=138;
    203:x:=139;
    204:x:=140;
    205:x:=141;
    206:x:=142;
    207:x:=143;
    208:x:=144;
    209:x:=145;
    210:x:=146;
    211:x:=147;
    212:x:=148;
    213:x:=149;
    214:x:=150;
    215:x:=151;
    216:x:=152;
    217:x:=153;
    218:x:=154;
    219:x:=155;
    220:x:=156;
    221:x:=157;
    222:x:=158;
    223:x:=159;
    224:x:=160;
    225:x:=161;
    226:x:=162;
    227:x:=163;
    228:x:=164;
    229:x:=165;
    184:x:=241;
    230:x:=166;
    231:x:=167;
    232:x:=168;
    233:x:=169;
    234:x:=170;
    235:x:=171;
    236:x:=172;
    237:x:=173;
    238:x:=174;
    239:x:=175;
    240:x:=224;
    241:x:=225;
    242:x:=226;
    243:x:=227;
    244:x:=228;
    245:x:=229;
    246:x:=230;
    247:x:=231;
    248:x:=232;
    249:x:=233;
    250:x:=234;
    251:x:=235;
    252:x:=236;
    253:x:=237;
    254:x:=238;
    255:x:=239;
   end;   {case}
   alt:=alt+chr(x);
 end;  {for}
 wintoalt:=alt;
end;

function koiutowin(koi:string):string;
var
 win:string;
 k:char;
 i,x:integer;
begin
 win:='';
 for i:=1 to length(koi) do begin
   k:=koi[i];
   x:=ord(k);
   if x<127 then begin
     win:=win+chr(x);
     continue;
   end;
   case x of
    254:x:=192;
    224:x:=193;
    225:x:=194;
    246:x:=195;
    228:x:=196;
    229:x:=197;
    179:x:=166;
    244:x:=198;
    227:x:=199;
    245:x:=200;
    232:x:=201;
    233:x:=202;
    234:x:=203;
    235:x:=204;
    236:x:=205;
    237:x:=206;
    238:x:=207;
    239:x:=208;
    255:x:=209;
    240:x:=210;
    241:x:=211;
    242:x:=212;
    243:x:=213;
    230:x:=214;
    226:x:=215;
    252:x:=216;
    251:x:=217;
    231:x:=218;
    248:x:=219;
    253:x:=220;
    249:x:=221;
    247:x:=222;
    250:x:=223;
    222:x:=224;
    192:x:=225;
    193:x:=226;
    214:x:=227;
    196:x:=228;
    197:x:=229;
    212:x:=230;
    195:x:=231;
    213:x:=232;
    200:x:=233;
    201:x:=234;
    202:x:=235;
    203:x:=236;
    204:x:=237;
    205:x:=238;
    206:x:=239;
    207:x:=240;
    223:x:=241;
    208:x:=242;
    209:x:=243;
    210:x:=244;
    211:x:=245;
    198:x:=246;
    194:x:=247;
    220:x:=248;
    219:x:=249;
    199:x:=250;
    216:x:=251;
    221:x:=252;
    217:x:=253;
    215:x:=254;
    218:x:=255;
   end;
   win:=win+chr(x);
 end;
 koiutowin:=win;
end;

function wintokoiu(win:string):string;
var
 koi:string;
 k:char;
 i,x:integer;
begin
 koi:='';
 for i:=1 to length(win) do begin
   k:=win[i];
   x:=ord(k);
   if x<127 then begin
     koi:=koi+chr(x);
     continue;
   end;
   case x of
    192:x:=254;
    193:x:=224;
    194:x:=225;
    195:x:=246;
    196:x:=228;
    197:x:=229;
    166:x:=179;
    198:x:=244;
    199:x:=227;
    200:x:=245;
    201:x:=232;
    202:x:=233;
    203:x:=234;
    204:x:=235;
    205:x:=236;
    206:x:=237;
    207:x:=238;
    208:x:=239;
    209:x:=255;
    210:x:=240;
    211:x:=241;
    212:x:=242;
    213:x:=243;
    214:x:=230;
    215:x:=226;
    216:x:=252;
    217:x:=251;
    218:x:=231;
    219:x:=248;
    220:x:=253;
    221:x:=249;
    222:x:=247;
    223:x:=250;
    224:x:=222;
    225:x:=192;
    226:x:=193;
    227:x:=214;
    228:x:=196;
    229:x:=197;
    230:x:=212;
    231:x:=195;
    232:x:=213;
    233:x:=200;
    234:x:=201;
    235:x:=202;
    236:x:=203;
    237:x:=204;
    238:x:=205;
    239:x:=206;
    240:x:=207;
    241:x:=223;
    242:x:=208;
    243:x:=209;
    244:x:=210;
    245:x:=211;
    246:x:=198;
    247:x:=194;
    248:x:=220;
    249:x:=219;
    250:x:=199;
    251:x:=216;
    252:x:=221;
    253:x:=217;
    254:x:=215;
    255:x:=218;
   end;
   koi:=koi+chr(x);
 end;
 wintokoiu:=koi;
end;

function koitowin(koi:string):string;
var
 win:string;
 k:char;
 i,x:integer;
begin
 win:='';
 for i:=1 to length(koi) do begin
   k:=koi[i];
   x:=ord(k);
   if x<127 then begin
     win:=win+chr(x);
     continue;
   end;
   case x of
    225:x:=192;
    226:x:=193;
    247:x:=194;
    231:x:=195;
    228:x:=196;
    229:x:=197;
    179:x:=168;
    246:x:=198;
    250:x:=199;
    233:x:=200;
    234:x:=201;
    235:x:=202;
    236:x:=203;
    237:x:=204;
    238:x:=205;
    239:x:=206;
    240:x:=207;
    242:x:=208;
    243:x:=209;
    244:x:=210;
    245:x:=211;
    230:x:=212;
    232:x:=213;
    227:x:=214;
    254:x:=215;
    251:x:=216;
    253:x:=217;
    255:x:=218;
    249:x:=219;
    248:x:=220;
    252:x:=221;
    224:x:=222;
    241:x:=223;
    193:x:=224;
    194:x:=225;
    215:x:=226;
    199:x:=227;
    196:x:=228;
    197:x:=229;
    163:x:=184;
    214:x:=230;
    218:x:=231;
    201:x:=232;
    202:x:=233;
    203:x:=234;
    204:x:=235;
    205:x:=236;
    206:x:=237;
    207:x:=238;
    208:x:=239;
    210:x:=240;
    211:x:=241;
    212:x:=242;
    213:x:=243;
    198:x:=244;
    200:x:=245;
    195:x:=246;
    222:x:=247;
    219:x:=248;
    221:x:=249;
    223:x:=250;
    217:x:=251;
    216:x:=252;
    220:x:=253;
    192:x:=254;
    209:x:=255;
   end;
   win:=win+chr(x);
 end;
 koitowin:=win;
end;

function wintokoi(win:string):string;
var
 koi:string;
 k:char;
 i,x:integer;
begin
 koi:='';
 for i:=1 to length(win) do begin
   k:=win[i];
   x:=ord(k);
   if x<127 then begin
     koi:=koi+chr(x);
     continue;
   end;
   case x of
    192:x:=225;
    193:x:=226;
    194:x:=247;
    195:x:=231;
    196:x:=228;
    197:x:=229;
    168:x:=179;
    198:x:=246;
    199:x:=250;
    200:x:=233;
    201:x:=234;
    202:x:=235;
    203:x:=236;
    204:x:=237;
    205:x:=238;
    206:x:=239;
    207:x:=240;
    208:x:=242;
    209:x:=243;
    210:x:=244;
    211:x:=245;
    212:x:=230;
    213:x:=232;
    214:x:=227;
    215:x:=254;
    216:x:=251;
    217:x:=253;
    218:x:=255;
    219:x:=249;
    220:x:=248;
    221:x:=252;
    222:x:=224;
    223:x:=241;
    224:x:=193;
    225:x:=194;
    226:x:=215;
    227:x:=199;
    228:x:=196;
    229:x:=197;
    184:x:=163;
    230:x:=214;
    231:x:=218;
    232:x:=201;
    233:x:=202;
    234:x:=203;
    235:x:=204;
    236:x:=205;
    237:x:=206;
    238:x:=207;
    239:x:=208;
    240:x:=210;
    241:x:=211;
    242:x:=212;
    243:x:=213;
    244:x:=198;
    245:x:=200;
    246:x:=195;
    247:x:=222;
    248:x:=219;
    249:x:=221;
    250:x:=223;
    251:x:=217;
    252:x:=216;
    253:x:=220;
    254:x:=192;
    255:x:=209;
   end;   {case}
   koi:=koi+chr(x);
 end;  {for}
 wintokoi:=koi;
end;

end.
